<template>
  <div id="app">
    <the-navbar :header="header" />
    <div v-if="!fetching">
      <the-header :services="services" />
      <v-tabs />
      <the-cpf-nota />
      <the-carousel :news="news" />
      <the-call-action />
      <the-footer />
      <the-partners-nav />
      <the-partners :partners="partners" />

      <div style="display: flex; flex-direction: column; align-items: center; justify-content: center; height: 90px; background-color: #271672; text-align: center;">
        <div style="display: flex; flex-direction: row; justify-content: center; align-items: center; width: 100%; margin-top: 15px;">
          <div style="padding-right: 15px;">
            <a
              target="_blank"
              href="https://www.facebook.com/abelardo.espindola.5?epa=SEARCH_BOX"
              style="color: white; text-decoration: none; font-size: 1.6rem;"
            >
              <div>
                <fa-icon :icon="['fab', 'facebook-f']" />
              </div>
            </a>
          </div>

          <div>
            <a
              target="_blank"
              href="https://www.instagram.com/institutoholistico/"
              style="color: white; text-decoration: none; font-size: 1.6rem;"
            >
              <div>
                <fa-icon :icon="['fab', 'instagram']" />
              </div>
            </a>
          </div>
        </div>

        <p style="font-size: 1.6rem; color: white">
          Instituto Holístico 2019 © Todos os Direitos Reservados
        </p>
      </div>
    </div>
    <div
      v-if="fetching"
      class="loading"
    >
      <fa-icon
        class="loading-icon"
        icon="spinner"
      />
    </div>
    <div
      v-if="error"
      class="error-container"
    >
      Ocorreu algum erro ao buscar os dados, tente novamente mais tarde.
    </div>
  </div>
</template>

<script>
import TheNavbar from '@/components/TheNavbar.vue';
import TheHeader from '@/components/TheHeader.vue';
import TheCarousel from '@/components/TheCarousel.vue';
import TheCallAction from '@/components/TheCallAction.vue';
import VTabs from '@/components/VTabs.vue';
import TheFooter from '@/components/TheFooter.vue';
import TheCpfNota from '@/components/TheCpfNota.vue';
import ThePartnersNav from '@/components/ThePartnersNav.vue';
import ThePartners from '@/components/ThePartners.vue';

export default {
  name: 'App',
  components: {
    TheNavbar,
    TheHeader,
    TheCarousel,
    TheCallAction,
    VTabs,
    TheFooter,
    TheCpfNota,
    ThePartnersNav,
    ThePartners,
  },
  data() {
    return {
      fetching: false,
      error: false,
      header: {},
      services: [],
      news: [],
      partners: [],
    };
  },
  async created() {
    this.fetching = true;
    const fetchHeader = await this.$http.get('/headers');
    // eslint-disable-next-line prefer-destructuring
    this.header = fetchHeader.data[0];

    try {
      const fetchServices = await this.$http.get('/subheaders');
      this.services = fetchServices.data;

      const fetchNews = await this.$http.get('/news');
      this.news = fetchNews.data;

      const fetchPartners = await this.$http.get('/partners');
      this.partners = fetchPartners.data;
      this.fetching = false;
    } catch (err) {
      this.fetching = false;
      this.error = true;
    }
  },
};
</script>

<style lang="stylus">
@import url('https://fonts.googleapis.com/css?family=Signika&display=swap')

:root
  --color-primary: #271672
  //--color-secondary: #FEF506
  --color-secondary: #271672
  --color-white: #ffffff
  --color-gray: #F3F3F3
  --color-black: #000000
  --width-page: 1000px

.swiper-pagination-bullet-active
  background var(--color-primary) !important

.loading, .error-container
  width 100%
  height 400px
  display flex
  align-items center
  justify-content center

.loading-icon
  animation spin 3s linear infinite
  font-size 5rem
  color var(--color-primary)

.error-container
  font-size 2rem
  font-family sans-serif
  color var(--color-primary)
  text-align center

@keyframes spin {
  0% { transform: rotate(0deg); }
  100% { transform: rotate(360deg); }
}

html
  font-size 10px
  font-family 'Signika', sans-serif

body
  margin 0

h3, h2
  font-weight normal

button
  transition all .1s ease-in-out

button:hover, button:active, button:focus
  transform scale(1.05)

.leaflet-top, .leaflet-left
  z-index 876
</style>
